# GoogleEarthEnterpriseImageryProvider

#### new Cesium.GoogleEarthEnterpriseImageryProvider(options)
Scene/GoogleEarthEnterpriseImageryProvider.js 100

Provides tiled imagery using the Google Earth Enterprise REST API. Notes: This provider is for use with the 3D Earth API of Google Earth Enterprise, `GoogleEarthEnterpriseMapsProvider` should be used with 2D Maps API.

Name | Type | Description
--- | --- | ---

`options`

Object

Object with the following properties:

Name | Type | Description
--- | --- | ---
`url` | Resource | String | The url of the Google Earth Enterprise server hosting the imagery.
`metadata` | GoogleEarthEnterpriseMetadata | A metadata object that can be used to share metadata requests with a GoogleEarthEnterpriseTerrainProvider.
`ellipsoid` | Ellipsoid | optional The ellipsoid. If not specified, the WGS84 ellipsoid is used.
`tileDiscardPolicy` | TileDiscardPolicy | optional The policy that determines if a tile is invalid and should be discarded. If this value is not specified, a default is to discard tiles that fail to download.
`credit` | Credit | String | optional A credit for the data source, which is displayed on the canvas.

##### Example:

    var geeMetadata = new GoogleEarthEnterpriseMetadata('http://www.earthenterprise.org/3d');
    var gee = new Cesium.GoogleEarthEnterpriseImageryProvider({
        metadata : geeMetadata
    });

##### See:

- GoogleEarthEnterpriseTerrainProvider
- ArcGisMapServerImageryProvider
- GoogleEarthEnterpriseMapsProvider
- createOpenStreetMapImageryProvider
- SingleTileImageryProvider
- createTileMapServiceImageryProvider
- WebMapServiceImageryProvider
- WebMapTileServiceImageryProvider
- UrlTemplateImageryProvider
- Cross-Origin Resource Sharing

### Members

#### readonlycredit : Credit
Scene/GoogleEarthEnterpriseImageryProvider.js 369

Gets the credit to display when this imagery provider is active. Typically this is used to credit the source of the imagery. This function should not be called before `GoogleEarthEnterpriseImageryProvider#ready` returns true.

#### readonlyerrorEvent : Event
Scene/GoogleEarthEnterpriseImageryProvider.js 332

Gets an event that is raised when the imagery provider encounters an asynchronous error. By subscribing to the event, you will be notified of the error and can potentially recover from it. Event listeners are passed an instance of `TileProviderError`.

#### readonlyhasAlphaChannel : Boolean
Scene/GoogleEarthEnterpriseImageryProvider.js 385

Gets a value indicating whether or not the images provided by this imagery provider include an alpha channel. If this property is false, an alpha channel, if present, will be ignored. If this property is true, any images without an alpha channel will be treated as if their alpha is 1.0 everywhere. Setting this property to false reduces memory usage and texture upload time.

#### readonlymaximumLevel : Number
Scene/GoogleEarthEnterpriseImageryProvider.js 234

Gets the maximum level-of-detail that can be requested. This function should not be called before `GoogleEarthEnterpriseImageryProvider#ready` returns true.

#### readonlyminimumLevel : Number
Scene/GoogleEarthEnterpriseImageryProvider.js 253

Gets the minimum level-of-detail that can be requested. This function should not be called before `GoogleEarthEnterpriseImageryProvider#ready` returns true.

#### readonlyproxy : Proxy
Scene/GoogleEarthEnterpriseImageryProvider.js 183

Gets the proxy used by this provider.

#### readonlyready : Boolean
Scene/GoogleEarthEnterpriseImageryProvider.js 344

Gets a value indicating whether or not the provider is ready for use.

#### readonlyreadyPromise : Promise.<Boolean>
Scene/GoogleEarthEnterpriseImageryProvider.js 356

Gets a promise that resolves to true when the provider is ready for use.

#### readonlyrectangle : Rectangle
Scene/GoogleEarthEnterpriseImageryProvider.js 291

Gets the rectangle, in radians, of the imagery provided by this instance. This function should not be called before `GoogleEarthEnterpriseImageryProvider#ready` returns true.

#### readonlytileDiscardPolicy : TileDiscardPolicy
Scene/GoogleEarthEnterpriseImageryProvider.js 312

Gets the tile discard policy. If not undefined, the discard policy is responsible for filtering out "missing" tiles via its shouldDiscardImage function. If this function returns undefined, no tiles are filtered. This function should not be called before `GoogleEarthEnterpriseImageryProvider#ready` returns true.

#### readonlytileHeight : Number
Scene/GoogleEarthEnterpriseImageryProvider.js 215

Gets the height of each tile, in pixels. This function should not be called before `GoogleEarthEnterpriseImageryProvider#ready` returns true.

#### readonlytileWidth : Number
Scene/GoogleEarthEnterpriseImageryProvider.js 196

Gets the width of each tile, in pixels. This function should not be called before `GoogleEarthEnterpriseImageryProvider#ready` returns true.

#### readonlytilingScheme : TilingScheme
Scene/GoogleEarthEnterpriseImageryProvider.js 272

Gets the tiling scheme used by this provider. This function should not be called before `GoogleEarthEnterpriseImageryProvider#ready` returns true.

#### readonlyurl : String
Scene/GoogleEarthEnterpriseImageryProvider.js 171

Gets the name of the Google Earth Enterprise server url hosting the imagery.

### Methods

#### getTileCredits(x, y, level) → Array.<Credit>
Scene/GoogleEarthEnterpriseImageryProvider.js 402

Gets the credits to be displayed when a given tile is displayed.

Name | Type | Description
--- | --- | ---
`x` | Number | The tile X coordinate.
`y` | Number | The tile Y coordinate.
`level` | Number | The tile level;

##### Returns:

The credits to be displayed when the tile is displayed.

##### Throws:

- DeveloperError : `getTileCredits` must not be called before the imagery provider is ready.

#### pickFeatures(x, y, level, longitude, latitude) → Promise.<Array.<ImageryLayerFeatureInfo>>|undefined
Scene/GoogleEarthEnterpriseImageryProvider.js 513

Picking features is not currently supported by this imagery provider, so this function simply returns undefined.

Name | Type | Description
--- | --- | ---
`x` | Number | The tile X coordinate.
`y` | Number | The tile Y coordinate.
`level` | Number | The tile level.
`longitude` | Number | The longitude at which to pick features.
`latitude` | Number | The latitude at which to pick features.

##### Returns:

A promise for the picked features that will resolve when the asynchronous picking completes. The resolved value is an array of `ImageryLayerFeatureInfo` instances. The array may be empty if no features are found at the given location. It may also be undefined if picking is not supported.

#### requestImage(x, y, level, request) → Promise.<(Image|Canvas)>|undefined
Scene/GoogleEarthEnterpriseImageryProvider.js 436

Requests the image for a given tile. This function should not be called before `GoogleEarthEnterpriseImageryProvider#ready` returns true.

Name | Type | Description
--- | --- | ---
`x` | Number | The tile X coordinate.
`y` | Number | The tile Y coordinate.
`level` | Number | The tile level.
`request` | Request | optional The request object. Intended for internal use only.

##### Returns:

A promise for the image that will resolve when the image is available, or undefined if there are too many active requests to the server, and the request should be retried later. The resolved image may be either an Image or a Canvas DOM object.

##### Throws:

- DeveloperError : `requestImage` must not be called before the imagery provider is ready.